require 'fastlane_core/ui/ui'

module Fastlane
  UI = FastlaneCore::UI unless Fastlane.const_defined?("UI")
  module Tools
      def self.log(msg)
        if msg == nil
          UI.message("")
        else
          UI.message("rocket-info : #{msg}")
        end
        
      end

      def self.logs(msg,array,number=false)
        unless msg == nil
          title(msg)
        end
        for i in 0..array.size-1
          element = array[i]
          if number == false
            UI.message("rocket-info : #{element}")
          else
            UI.message("rocket-info : #{i+1}.#{element}")
          end
        end
        
      end


      def self.logh(hash)
        hash.keys.each do |key|
          title(key)
          value = hash[key]

          if value.is_a? Array
            value.each do |element|
              UI.message("rocket-info : #{element}")
            end
          else
            UI.message("rocket-info : #{value}")
          end
        end
      end

      def self.title(msg)
        UI.message("")
        UI.message("\033[32mrocket-title : --- #{msg} ---↓↓\033[0m")
      end

      def self.error(msg)
        UI.user_error!("rocket-error : #{msg}")
        # UI.message("\033[31mrocket-error:#{msg}\033[0m")
      end

      def self.warning(msg)
        UI.message("\033[33mrocket-warning : --- #{msg} ---↓↓\033[0m")
      end

      #格式化输出
      def self.formatLog(params,available_options)
        string = []
        available_options.each do |configItem|
            string << "#{configItem.key} => #{params[configItem.key]}"
        end
        logs("参数信息↓↓",string)   
      end
  end
end
