module Fastlane
    module Tools
        
        #执行shell命令
        #throw_exception == true  抛出异常
        #throw_exception == false 报错终止命令
        def self.shell(shell,throw_exception=true)
            status = system "#{shell}"
            if throw_exception == false && status == false
              format_shell = "\n\n#{shell.gsub("&&","\n")}\n"
              raise "执行shell命令失败 => #{format_shell} "
            end
            return status
        end

        #批量执行
        def self.shell_list(shells,throw_exception=true)
            txt = ""
            shells.each do |shell|
              if txt == ""
                txt += "#{shell}"
              else
                txt += "&&#{shell}"
              end
            end
            return shell(txt,throw_exception)
        end

        #获取shell的返回结果
        def self.return_shell(shell,throw_exception=true)
            code = `#{shell}`.chomp
            status = $?.to_i
            unless status == 0
              if throw_exception == false
                error_log("状态码 => #{status}")
                format_shell = "\n#{shell.gsub("&&","\n")}"
                raise "执行命令失败 => #{format_shell}"
              else
                return -1
              end
            end
            return code
          end

    end
  end
  